
#include  <stdio.h>

#define funcScope 

__attribute__ ((noinline))
funcScope int memcmp1( const int a[], const int b[], int len ) {
  for( int i = 0; i < len; i++ ){
    if( a[i] != b[i] ){
      return a[i] - b[i];
    }
  }
  return 0;
}

__attribute__ ((noinline))
funcScope int memcmp2( const int a[], const int b[], int len ){
  while( len >= 0 ){
    len--;
    if( a[len] != b[len] ){
      return a[len] - b[len];
    }
  }
  return 0;
}

__attribute__ ((noinline))
funcScope int memcmp3( const int *a, const int *b, int len ){
  while( len >= 0 ){
    len--;
    if( *a != *b ){
      return *a - *b;
    }
    a++;
    b++;
  }
  return 0;
}

__attribute__ ((noinline))
funcScope int memcmp4( const int *a, const int *b, int len ){
  for( ; len >= 0; len--, a++, b++ ){
    if( *a != *b ){
      return *a - *b;
    }
  }
  return 0;
}

__attribute__ ((noinline))
funcScope void sum1( const int *a, const int *b, int *c, int len ){
  for( int i = 0; i < len; i++ ){
    c[i] = a[i] + b[i];
  }
}

__attribute__ ((noinline))
funcScope void sum2( const int *a, const int *b, int *c, int len ){
  while( len >= 0 ){
    len--;
    *c = *a + *b;
    a++;
    b++;
    c++;
  }
}
__attribute__ ((noinline))
funcScope int scalar1( const int *a, const int *b, int len ){
  int sum = 0;
  for( int i = 0; i < len; i++ ){
    sum += a[i] * b[i];
  }
  return sum;
}

#define MAX_LEN 16

int main() {
  int a[MAX_LEN], b[MAX_LEN];
  int n;
  
  printf( "please enter the number of elements: \n" );
  scanf( "%i", &n );
  
  if( n > MAX_LEN ){
    n = MAX_LEN;
  }

  printf( "please enter the %i elements of a: \n", n );
  for( int i = 0; i < n; i++ ){
    scanf( "%i", &a[i] );
  }
  printf( "please enter the %i elements of b: \n", n );
  for( int i = 0; i < n; i++ ){
    scanf( "%i", &b[i] );
  }
  
  printf( "result of memcmp1 is %i\n", memcmp1( a, b, n ) );
  printf( "result of memcmp2 is %i\n", memcmp2( a, b, n ) );
  printf( "result of memcmp3 is %i\n", memcmp3( a, b, n ) );
  printf( "result of memcmp4 is %i\n", memcmp4( a, b, n ) );
  printf( "result of scalar1 is %i\n", scalar1( a, b, n ) );
  
  int c[MAX_LEN];
  
  sum1( a, b, c, n );
  printf( "result of sum1 is" );
  for( int i = 0; i < n; i++ ){
    printf( " %i", c[i] );
  }
  printf( "\n" );
  
  sum2( a, b, c, n );
  printf( "result of sum2 is" );
  for( int i = 0; i < n; i++ ){
    printf( " %i", c[i] );
  }
  printf( "\n" );
  
  return  0;
}


